const async = require('async');
const Common = require('ethereumjs-common').default;
const Block = require('ethereumjs-block');
const Blockchain = require('ethereumjs-blockchain');
const level = require('level');
const levelMem = require('level-mem')
const ethUtil = require('ethereumjs-util');
const BN = ethUtil.BN;

const constants = {
    gasPrice: '0x00', // Ensure that there is no need to provide ether to accounts running smart contracts
    gasLimit: '0x1000000000',
}

const biggerTimestamp = (from, current) => Math.max(current, from+1);

// Complements to the blockchain object
const bufBE8 = n => n.toArrayLike(Buffer, 'be', 8) // convert BN to big endian Buffer
const txLookupPrefix = Buffer.from('l'); // txLookupPrefix + hash -> transaction/receipt lookup metadata
const chainParamsKey = 'fr.yahoo.guenoledc.chainParams';

const txLookupKey = hash => Buffer.concat([txLookupPrefix, hash]);

class BlockchainWrapper {
    constructor(opts, storageLevelDB) {
        if(!opts.context) throw new TypeError('Expecting a valid ContextDataProvider')
        this.contextDataProvider = opts.context

        this.lastBlockNumber = undefined; // the last known block
        this.db = storageLevelDB || new level('./.ethvmdata');
        // chainId, extra_data
        if(!opts._chainParams)
            this.common = new Common({
                name:'Private Chain '+opts.chainId, 
                networkId: opts.chainId, 
                genesis:{
                    "difficulty": "0x000000",
                    "extraData": opts.extra_data || "0x00",
                    "gasLimit": opts.gasLimit || constants.gasLimit,
                    "nonce": "0x00",
                    "timestamp": 1549734809,
                    // hard coded stateRoot generated by deploying the 8 precompiled with a not secure merkle-patricia-trie
                    //"stateRoot": '0x41c488877f4bd7f076e7a46574f86eb2e58bb101aad9fd4da0dbf9b60ec8c949' 
                    // hard coded stateRoot generated by deploying the 8 precompiled with a secure merkle-patricia-trie
                    "stateRoot": '0x5766c887a7240e4d1c035ccd3830a2f6a0c03d213a9f0b9b27c774916a4abcce'
                }, 
                hardforks:['byzantium'], 
                bootstrapNodes:[]
            }, 'byzantium');
        else { // we have been given a serialized Common instance
            this.common = new Common(opts._chainParams, opts._hardfork)
        }
        this.extra_data = this.common.genesis().extraData // use this extra data for all blocks and it can be reset by miner_setExtra premise
        this.minGasPrice = new BN(0) // start with a no minimum. Can be changed via the miner_setGasPrice rpc premise
        this.blockchain = new Blockchain({common: this.common, db: this.db, validate:true});
        // below, to falke the POW verification so the mining is not necessary and any blockhash becomes valid
        // but awaits the asynchronous blockchain initialization with the default genesis block
    }

    static newBlockchain(chainId, extra_data, context, storageLevelDB, cbCompletion){
        let self = null
        async.seq(
            cb=>{
                storageLevelDB.get(chainParamsKey, (err, chainParamsJson) => {
                    if(err)
                        if( err.notFound ) cb(null, null);
                        else cb(err, null)
                    else cb(null, chainParamsJson)
                })
            },
            (chainParamsJson, cb)=>{
                let opts = {chainId: chainId, extra_data: extra_data}
                if(chainParamsJson) opts = JSON.parse(chainParamsJson)
                opts.context=context
                self = new BlockchainWrapper(opts, storageLevelDB);
                self.blockchain._initLock.await(()=>{
                    self.blockchain.ethash = { verifyPOW: (block, cb)=>{ cb(true) } };
                    self.blockchain.getLatestBlock( (err, lastBlock) => {
                        if(!err) self.lastBlockNumber = lastBlock.header.number;
                        else self.lastBlockNumber = new Buffer(0)
                        cb();
                    } );
                });
            },
            cb=>{
                storageLevelDB.put(chainParamsKey, JSON.stringify(self.common), cb)
            }
        )(err=>cbCompletion(err, self))
               
        return self;
    }

    hasGenesisBlock(cb) {
        this.blockchain._initLock.await(()=>{
            if( this.blockchain.meta.rawHead ) cb(null, true);
            else cb(null, false);
        })
    }
    
    putNewTransactionsInBLock(trie, signedTransactions, finalcb) {
        // The total gas of the signedTransactions are below the previous block gasLimit
        // final callback must be function(error, blockJustCreated)
        const self = this;
        if( !Array.isArray(signedTransactions) ) signedTransactions = [signedTransactions];
        
        async.waterfall([
            (cb) => {
                //let number = new BN(blockHead.header.number);
                //console.log("Head block:", number.toString(10), blockHead.header.hash().toString('hex'));
                // build a new block with the transactions serialized and no uncles
                let data = {
                    "header" : {
                        "nonce" : "0x01",
                        // other attributes are set in the putBlock baced on the parent block
                    },
                    "transactions" : signedTransactions.map( (tx) => tx.serialize() ),
                    "uncleHeaders" : []                
                }; 
                if(self.coinbase)
                    data.header.coinbase = self.coinbase;
                let block = new Block(data, {common: self.common});
                cb(null, block);
            },
            // putBlock in the chain
            (block, cb) => {
                self.putBlock(trie, block, cb)
            },
        ], finalcb); // final callback must be function(error, blockJustCreated)

    }
    putBlock(trie, block, finalcb) {
        if(!trie) return finalcb('invalid trie state in putBlock');
        if(!block) return finalcb('invalid block in putBlock');
        let self = this;
        async.waterfall([
            // get last block
            (cb) => self.blockchain.getLatestBlock(cb),
            // amend provided block to fit into the chain
            (blockHead, cb) => {
                block.header.timestamp = biggerTimestamp(
                    (new BN(blockHead.header.timestamp)).toNumber(), 
                    self.contextDataProvider.getTimestamp());
                block.header.number = (new BN(blockHead.header.number)).iaddn(1).toBuffer();
                block.header.parentHash = blockHead.header.hash();
                block.header.gasLimit = blockHead.header.gasLimit;
                block.header.extraData = this.extra_data; // set by the miner_setExtra rpc premise
                // must be after the timestamp
                block.header.difficulty = block.header.canonicalDifficulty(blockHead);
                block.header.stateRoot = trie.root; // will need to be modified during cm processing
                cb(null);
            },
            // create the transactionTrie and get the root, then set the root in the header
            (cb) => {
                block.genTxTrie(()=>{
                //console.log("CHECK TX TRIE:", block.txTrie.root.toString('hex'), block.header.transactionsTrie.toString('hex'));
                block.header.transactionsTrie = block.txTrie.root;
                cb(null, block);
                })
            },
            // check the block integrity and if ok, put it in the blockchain
            (block, cb) => {
                block.validate(self.blockchain, (err) => {
                    if(err) cb(err, null);
                    else self.blockchain.putBlock(block, (err) => {
                        if( !err ) self.lastBlockNumber = block.header.number;
                        cb(err, block);
                    });
                });
            },
        ], finalcb); // final callback must be function(error, blockJustCreated)
    }

    persistBlock(block, finalcb) {
        // final callback must be function(error)
        const self = this;
        async.waterfall([
            // first get the latest head and delete the block if at the same hight as the new one
            (cb) => self.blockchain.getLatestBlock(cb),
            (blockHead, cb) => {
                if(blockHead.header.number.equals(block.header.number))
                    self.blockchain.delBlock(blockHead.hash(), (err)=>cb(err) );
                else cb(null);
            },
            // check the block integrity and if ok, put it in the blockchain
            (cb) => block.validate(self.blockchain, cb),
            (cb) => self.blockchain.putBlock(block, cb),
            (putBlockResult, cb) => {
                    // TODO: 1) pass the name ('vm') as a parameter or get it from the blockchain object
                    // TODO: 2) understand how it can be done better than intervening into the blockchain iterator mechanism
                    self.blockchain._heads['vm'] = block.hash();
                    self.lastBlockNumber = block.header.number;
                    cb(null, block);
                    },
            // record the txHashes to BlockHash+index 
            (block, cb) => {
                async.forEachOfSeries(
                    block.transactions, 
                    (tx, index, txCb) => self.putTxBlockLookup(tx.hash(), block.hash(), index, txCb),
                    err=>cb(err, block));
            }
        ], finalcb); // final callback must be function(error, blockJustCreated)
    }

    vmOpts() {
        return {
            blockchain: this.blockchain, 
            chain: this.common._chainParams
        };
    }

    txOpts() {
        return {
            gasPrice: constants.gasPrice,
            gasLimit: constants.gasLimit,
            chainId : this.common.networkId(),
            chainName: this.common.chainName()
        };
    }

    putTxBlockLookup(txHash, blockHash, txIndex, cb) {
        //console.log('putTxBlockLookup', txHash, blockHash, txIndex);
        let dbOps = [
            {
                type: 'put',
                key: txLookupKey(ethUtil.toBuffer(txHash)),
                keyEncoding: 'binary',
                valueEncoding: 'binary',
                value: ethUtil.rlp.encode([ ethUtil.toBuffer(blockHash), txIndex])
            }
        ];
        this.blockchain._batchDbOps(dbOps, cb);
    }
    
    getTxBlockLookup(txHash, cb) { // cb is function(err, {blockHash: , index: })
        this.blockchain.db.get(txLookupKey(ethUtil.toBuffer(txHash)), {
            keyEncoding: 'binary',
            valueEncoding: 'binary'
          }, (err, encodedLookup) => {
            if (err) return cb(err)
            let lookup = ethUtil.rlp.decode(encodedLookup);
            cb(null, {blockHash: ethUtil.bufferToHex(lookup[0]), index: new BN(lookup[1])});
          })
    } 
}

module.exports = BlockchainWrapper;